(ns damp.ekeko.logic
   (:refer-clojure :exclude [==])
   (:use [clojure.core.logic]))

;(defmacro equals [& rest] 
;  `(== ~@rest))

;(def #^{:macro true} equals #'==) ;http://stackoverflow.com/questions/1317396/define-a-synonym-for-a-clojure-macro


;makes core.logic's private extract-vars publicly accessible
;http://christophermaier.name/blog/2011/04/30/not-so-private-clojure-functions/
;(def extract-vars #'clojure.core.logic/extract-vars)
  


(defn ekeko-lvar-sym? [s]
  (= (first (str s)) \?))

(defn ekeko-extract-vars
  ([p]
     (set (cond
           (ekeko-lvar-sym? p) [p]
           (coll? p) (filter ekeko-lvar-sym? (flatten p))
           :else nil))))



;BUG in equals: fn wordt als een variabele herkend ....

;(macroexpand-1 '(equals ?keywords (map (fn [^Class c]
;                                                                          (ekeko-keyword-for-class c))
;                                                                        (node-classes))))
;(clojure.core.logic/project [fn c ekeko-keyword-for-class node-classes] (clojure.core.logic/== ?keywords (map (fn [c] (ekeko-keyword-for-class c)) (node-classes))))
;daarom toch maar de conventie aanhouden dat logische variabelen met een vraagteken moeten beginnen

;hier zou ook nog een fresh op lvar moeten gebeuren als die bestaat, anders niet...
(defmacro equals [lvar exp & rest]
  (let [expvars#  (ekeko-extract-vars exp)] 
    `(project [~@expvars#]
      (== ~lvar ~exp)
      ~@rest)))

(defmacro succeeds [exp]
  `(equals true ~exp))

(defmacro fails [exp]
  `(== false ~exp))



(defmacro contains [c e]
  `(fresh [s#]
     (equals s# (seq ~c))
     (membero ~e s#)))


(defmacro v+ [v]
  `(project [~v] (fails (lvar? ~v))))

(defmacro v- [v]
  `(project [~v] (succeeds (lvar? ~v))))


(def #^{:macro true} equals-without-exception #'equals) 

;(defmacro equals-without-exception [lvar exp]
;  `(fresh [e#]
;     (equals ~lvar (try ~exp (catch Exception e# false)))))

(defmacro succeeds-without-exception [exp]
  `(equals-without-exception true ~exp))






