(ns damp.ekeko.reorderer
  (:import [damp.ekeko.util.search.ISearchProblem]) ;because of records that compile to classes
  (:use [damp.ekeko.util search]
        [damp.ekeko logic]))

;todo-paper: in een regel zelf de verschillende condes annoteren met een kost (in geval multi-directional met +v en -v)
;todo-later: switch to meta-data on variables
;todo-immediate: pattern matching gebruiken
(defn condition-ground-pre [condition]
  (let [vars (ekeko-extract-vars)]
    ;cond
    '() ;heeft als effect dat geen enkele conditie precondities heeft
    ))

(defn condition-ground-post [condition]
  (let [vars (ekeko-extract-vars)]
    ;cond
    vars ;zal als effect hebben dat eender welke conditie alles ground
    ))

(defrecord ConditionOrderState [query remaining ground unground ])

;groundvar should be the one that corresponds to snippet's ast node so that it is put first
(defn make-co-state [conditions groundvar]
  ;(let [variables (ekeko-extract-vars conditions)]
  ;  (ConditionOrderState. '() conditions #{groundvar} (set variables)))
  (ConditionOrderState. '() conditions  #{} #{}))

 
(defn co-state-goal? [state]
  (empty? (:remaining state)))

(defn co-state-successors [state]
  (map 
    (fn [condition]
      (-> 
        state
        (update-in [:remaining] (fn [remaining] (remove #(= % condition))))
        (update-in [:query] (fn [original] (conj original condition))) 
        (update-in [:ground] (fn [ground] (concat (condition-ground-post condition) ground))) 
        (update-in [:unground] (fn [unground] (disj unground (condition-ground-pre condition))))))
    (let [ground (:ground state)]
      (filter
        (fn [condition]
          (contains? ground condition))
        (:remaining state)))))


;state
;-----

;state = sequence of conditions, remaining conditions, col of bound vars, col of unbound vars
;successor = geldige conditie toevoegen aan sequence
; geldig: alle pre-ground variabelen ground 
;goal = geen remaining conditions

;conditie:
; pre-ground required
; post-ground 
; will backtrack 

;heuristiek: verkies condities waarin variabelen van vorige voorkomen
;verkies condities die veel ineens grounden


(defrecord EkekoConditionReorderProblem [conditions groundvar] 
  ISearchProblem
  (is-goal? [this state] (co-state-goal? state))
  (init-state [this] (make-co-state conditions groundvar))
  (successors [this state] (co-state-successors state)))



(uniform-cost-search (EkekoConditionReorderProblem. (list 1 2) '?bar))






