(ns damp.ekeko.util.maps)

;=> (damp.ekeko.util.maps/transpose-multimap {:a #{1 2} :b #{2} :c #{1 2 3} :d #{}})
;{3 #{:c}, 2 #{:a :c :b}, 1 #{:a :c}}

(defn transpose-multimap [mp]
  (reduce 
    (fn [sofar [k vset]]
      (merge-with 
        #(conj %1 %2)
        sofar
        (zipmap vset (repeat k))))
    (zipmap (apply clojure.set/union (vals mp))
            (repeat #{}))
    mp))
      