(ns damp.ekeko.util.mattias
  (:refer-clojure :exclude [==])
  (:use [damp.ekeko logic reification])
  (:use [clojure.core.logic])
  )



(defn has-single [?keyword ?node ?child]
  (fresh [?lst]
     (has ?keyword ?node ?lst) 
     (equals 1 (.size ?lst))
     (equals ?child (first ?lst))))
  
(defn expression-of-type-binding
  [?exp ?binding]
  (all 
    (ast :Expression ?exp)
    (equals ?binding (.resolveTypeBinding ?exp))))

;only works for ground ?binding
(defn type-binding-has-qualified-name [?binding ?string]
  (all 
    (equals ?string (.getQualifiedName ?binding))))

(defn type-binding-is-discrete [?binding]
  (fresh [?name]
         (type-binding-has-qualified-name ?binding ?name)
         (conde [(== ?name "java.lang.Integer")]
                [(== ?name "int")])))


(defn expression-of-discrete-type [?exp]
  (fresh [?binding]
         (expression-of-type-binding ?exp ?binding)
         (type-binding-is-discrete ?binding)))
         



(defmacro toreplace [logicvars & goals]
  `(run* [resultvar#] 
         (fresh [~@logicvars]
                (equals resultvar# [~@logicvars])
                ~@goals)))


  
(defn for-mattias 
  [?for ?name ?initExpression ?condition ?update ?mslist]
  (fresh [?init ?fragment] 
    (ast :ForStatement ?for)

    ;?initExpression
    (has-single :initializers ?for ?init) 
    (ast :VariableDeclarationExpression ?init)
    (has-single :fragments ?init ?fragment)
    (expression-of-discrete-type ?init)
    (has :name ?fragment ?name)
    (has :initializer ?fragment ?initExpression)

    ;?condition
    (has :expression ?for ?condition)
    (ast :Expression ?condition)
    
    ;?update
    (has-single :updaters ?for ?update)
    
    ;inner statements
     (fresh [?body ?slist ?_name ?_initExpression ?_condition ?_update ?_mslist] 
            (has :body ?for ?body)
            (conde 
              [(for-mattias ?body ?_name ?_initExpression ?_condition ?_update ?_mslist) (== ?slist [?body])]
              [(ast :Block ?body)
               (project [?body]
                        (== ?mslist
                            (vec (toreplace [?c]
                                       (child :statements ?body ?c)
                                       (for-mattias ?c ?_name ?_initExpression ?_condition ?_update ?_mslist)
                                       ))))]
             ))
    ))

    