(ns damp.ekeko.evaluator.baristaeval
   (:refer-clojure :exclude [==])
   (:use [damp.ekeko.util jobs text])
   (:use clojure.core.logic))


;defrecord/type maken


(defn illimani-query-to-kanren-query [q logicvars]
  (let [resultvar (gensym "resultvar")]
    `(run* [~resultvar] 
     (fresh [~@logicvars]
       (== ~resultvar [~@logicvars])
       ~@q))))


(defn illimani-results-to-map [logicvars sqc]
  (let [vars (map str logicvars)
        hmp (new java.util.HashMap (count sqc))]
    (doseq [v vars]
      (.put hmp v (new java.util.LinkedList)))
    (doseq [resultv sqc
            [idx rslt] ;(indexed resultv) ;<- clojure cannot find this 
                      (map vector (iterate clojure.core/inc 0) resultv)
                      ]
                      (.add ^java.util.LinkedList (.get hmp (nth vars idx)) rslt))
    hmp))

(defn make-illimani-evaluator [query]
 (proxy [barista.IEvaluator] []
                  ;public IResults getAllResults();
                  (getAllResults []
                    (let [qform (read-string (str "(" query ")"))
                          lvars (vec (extract-vars qform))
                          kanrenquery (illimani-query-to-kanren-query qform lvars)
                          start (. System (nanoTime))
                          results
                          ;(as-synchronous-job 
                          ;  (str "Evaluating query: " (ellipsis query))
                          ;  (fn [] 
                              ;;maybe a new ns can be created using ns or in-ns instead, passing the logic files that should be loaded
                              (binding [*ns* (the-ns 'damp.illimani.barista.IllimaniActivator)]
                                (eval kanrenquery));))
                          end (. System (nanoTime)) 
                          ;als results een lazy seq is, dan zou next result etc kunnen werken .. maar dan mag ik nu niet de cnt nemen
                          cnt (count results)]
                      (proxy 
                        [barista.IResults] []
                        ;public int getSize();
                        (getSize [] cnt)
                        ;public Map toMap(); //Map<String, List<Object>> 
                        (toMap []
                         (illimani-results-to-map lvars results))
                        ;public boolean isSuccess();
                        (isSuccess [] (> cnt 0))
                        ;public long getElapsedTime(); 
                        (getElapsedTime [] 
                         (/ (double (- end start)) 1000000.0))
                      )))
                  ;public IResults getNextResult();
                  ;public IResults getNextResults(int amount);
                  ;public boolean hasMoreResults();
                  (hasMoreResults []
                                  false)
                  ))








